## $Id: browser.py 12760 2015-03-14 05:46:24Z henrik $
##
## Copyright (C) 2015 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""UI components for payments.
"""
import grok
from waeup.ikoba.browser.breadcrumbs import Breadcrumb
from waeup.ikoba.interfaces import MessageFactory as _
from waeup.ikoba.payments.interfaces import IPayment
from waeup.ikoba.payments.payment import find_payable_from_payable_id

class PaymentBreadcrumb(Breadcrumb):
    """A breadcrumb for payment.
    """
    grok.context(IPayment)
    parent = grok.getSite()
    target = None

    @property
    def title(self):
        id_part = self.context.payment_id[4:12]
        return _(u"Payment ${id}", mapping={'id': id_part})

    @property
    def parent(self):
        """We display the payments payable as parent.
        """
        payment = self.context
        payable = find_payable_from_payable_id(payment.payable_id)
        if payable is None:
            # fallback: display site home as parent
            return (grok.getSite(), 'index')
        return (payable, 'index')